package util

import (
	"math/rand"
	"strings"
	"game/base/log"
)

//随机范围 [1,max]
func GetRandomNums(max int64, length int, except uint64) []uint64 {
	var res []uint64
	var has bool
	var loop int

	for len(res) < length {
		if loop > 10000 {
			break
		}
		loop++
		t := uint64(rand.Int63n(max)) + 1
		if t == except {
			continue
		}
		for _, v := range res {
			if v == t {
				has = true
			}
		}
		if !has {
			res = append(res, t)
		}
		has = false
	}
	return res
}

func RandRangeInt64(start int64, end int64) int64 {
	if start > end {
		return 0
	}

	index := end - start
	if index <= 0 {
		index = 1
	}
	return start + rand.Int63n(index)
}

func RandRange(start int32, end int32) int32 {
	if start > end {
		return 0
	}

	index := end - start
	if index <= 0 {
		index = 1
	}
	return start + rand.Int31n(index)
}

// WeightRandom 加权随机算法
func WeightRandom(list []uint32) uint32 {
	if len(list) == 0 {
		return 0
	}

	var weight uint32
	for _, v := range list {
		weight += v
	}

	if weight <= 0 {
		log.Error("WeightRandom weight:", weight, " list:", list)
		return 0
	}

	index := rand.Int31n(int32(weight))

	var curWeight, tmp uint32
	for k, v := range list {
		curWeight += v
		if uint32(index) < curWeight {
			tmp = uint32(k)
			break
		}
	}

	return tmp
}

func WeightToList(str, sep1, sep2 string) (itemIDList []uint64, weightList []uint32) {
	params := strings.Split(str, sep1)
	for _, j := range params {
		param := strings.Split(j, sep2)
		if len(param) != 2 {
			continue
		}

		itemIDList = append(itemIDList, StringToUint64(param[0]))
		weightList = append(weightList, StringToUint32(param[1]))
	}
	return
}

// WeightRandomUint32 加权随机算法
func WeightRandomUint32(list map[uint32]float32) uint32 {
	if len(list) == 0 {
		return 0
	}
	var weight float32
	for _, v := range list {
		weight += v
	}

	index := rand.Int63n(int64(weight))

	var curWeight float32
	for k, v := range list {
		curWeight += v
		if index < int64(curWeight) {
			return k
		}
	}

	return 0
}

// GenRandomString 随机字符串
func GenRandomString() string {
	str := "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
	bytes := []byte(str)
	var result []byte
	for i := 0; i < 16; i++ {
		result = append(result, bytes[rand.Intn(len(bytes))])
	}
	return string(result)
}
