package config

var CmConfig CommonConfig

type CommonConfig struct {
	Redis            *RedisConfig `yaml:"redis"`            // redis 地址
	LogLevel         string       `yaml:"logLevel"`         // 日志等级
	LogPath          string       `yaml:"logPath"`          // 日志路径
	AppPayUrl        string       `yaml:"appPayUrl"`        // 支付的回调地址，某些平台需要作为参数传递
	ExcelPath        string       `yaml:"excelPath"`        // 配置文件地址
	Addr             string       `yaml:"addr"`             // 监听地址
	Debug            bool         `yaml:"debug"`            // 是否测试环境
	IsHGameDebug     bool         `yaml:"isHGameDebug"`     // 测试的充值渠道
	IsHuaweiPayDebug bool         `yaml:"isHuaweiPayDebug"` // 测试华为的充值渠道
}

type RedisConfig struct {
	Host     string `yaml:"host"`
	Password string `yaml:"password"`
}
