package excel

import (
	"github.com/fsnotify/fsnotify"
	"game/base/log"
	"strings"
	"sync"
)
var  loadLock sync.RWMutex
var path1 string
func LoadExcel(path string) {
	path1 = path
	loadAll()
	go func() {
		watcher, err := fsnotify.NewWatcher()
		if err != nil {
			log.Error(err)
			return
		}
		defer watcher.Close()

		done := make(chan bool)
		go func() {
			for {
				select {
				case ev := <-watcher.Events:
					log.Infof("Watch %s Op %s", ev.Name, ev.Op)
						if ev.Op&fsnotify.Write == fsnotify.Write || ev.Op&fsnotify.Create == fsnotify.Create {
							log.Info("Start Reload!")
							doLoadExcel(ev.Name)
						}
				case err := <-watcher.Errors:
					log.Error(err)
				}
			}
		}()

		if err = watcher.Add(path); err != nil {
			log.Error(err)
		} else {
			log.Info("Watch excel path")
		}

		<-done
	}()
}


func doLoadExcel(file string){
	if strings.HasSuffix(file, "PlatformIds.json"){
		loadPlatformIdTable(file)
	}
}


func loadAll(){
	loadPlatformIdTable(path1+"/PlatformIds.json")
}